#include <bits/stdc++.h>

using namespace std;

string code(string s) {
    string ans = "";
    if (s.empty()) return ans;
    int curnum = 1;
    for (int j = 1; j < s.size(); j++) {
        if (s[j] == s[j - 1]) {
            curnum++;
            continue;
        }
        if (curnum != 1) ans += to_string(curnum);
        ans += s[j - 1];
        curnum = 1;
    }
    if (curnum != 1) ans += to_string(curnum);
    ans += s.back();
    return ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    string S = "AGCT";
    string s;

    cin >> s;

    vector <pair <int, char>> t;

    int curnum = 0;

    for (int i = 0; i < s.size(); i++) {
        if ('0' <= s[i] && s[i] <= '9') {
            curnum *= 10;
            curnum += (s[i] - '0');
        } else {
            if (curnum == 0) {
                t.emplace_back(1, s[i]);
            } else {
                t.emplace_back(curnum, s[i]);
            }
            curnum = 0;
        }
    }

    string F;

    for (int i = 0; i < t.size(); i++) {
        for (int j = 0; j < t[i].first; j++) {
            F += t[i].second;
        }
    }

    // delete

    int minans = 1000000000, maxans = -1000000000;
    int mintype = -1, maxtype = -1;
    int minpos = -1, maxpos = -1;
    char minchar = 'X', maxchar = 'X';

    for (int i = 0; i < F.size(); i++) {
        string H;

        for (int j = 0; j < i; j++) {
            H += F[j];
        }
        for (int j = i + 1; j < F.size(); j++) {
            H += F[j];
        }

        string ans = code(H);
        int ANS = ans.size();

        if (ans.size() < minans) {
            minans = ans.size();
            mintype = 2;
            minpos = i + 1;
        }

        if (ANS > maxans) {
            maxans = ans.size();
            maxtype = 2;
            maxpos = i + 1;
        }
    }


    //change

    for (int i = 0; i < F.size(); i++) {
        for (char nc : S) {
            if (nc == F[i]) continue;
            string H = F;
            H[i] = nc;
            string ans = code(H);

            if (ans.size() < minans) {
                minans = ans.size();
                mintype = 3;
                minpos = i + 1;
                minchar = nc;
            }
            if (ans.size() > maxans) {
                maxans = ans.size();
                maxtype = 3;
                maxpos = i + 1;
                maxchar = nc;
            }
        }
    }

    //insert

    for (int i = 0; i < F.size(); i++) {
        for (char nc : S) {
            string H;
            for (int j = 0; j < i; j++) {
                H += F[j];
            }
            H += nc;
            for (int j = i; j < F.size(); j++) {
                H += F[j];
            }

            string ans = code(H);

            if (ans.size() < minans) {
                minans = ans.size();
                mintype = 1;
                minpos = i + 1;
                minchar = nc;
            }
            if (ans.size() > maxans) {
                maxans = ans.size();
                maxtype = 1;
                maxpos = i + 1;
                maxchar = nc;
            }
        }
    }

    for (char nc : S) {
        string H = F + nc;

        string ans = code(H);

        if (ans.size() < minans) {
            minans = ans.size();
            mintype = 1;
            minpos = F.size();
            minchar = nc;
        }
        if (ans.size() > maxans) {
            maxans = ans.size();
            maxtype = 1;
            maxpos = F.size();
            maxchar = nc;
        }
    }

    cout << mintype << " " << minpos;
    if (mintype == 2) {
        cout << endl;
    } else {
        cout << " " << minchar << endl;
    }

    cout << maxtype << " " << maxpos;
    if (maxtype == 2) {
        cout << endl;
    } else {
        cout << " " << maxchar << endl;
    }

    return 0;
}

//5AC5A2C