#include <bits/stdc++.h>

using namespace std;

int STMINANS, STMAXANS, SMMINANS, SMMAXANS;

string S = "AGCT";

int get_size(int n) {
    int ans = 0;
    while (n > 0) {
        ans++;
        n /= 10;
    }
    return ans;
}


string code(string s) {
    string ans = "";
    if (s.empty()) return ans;
    int curnum = 1;
    for (int j = 1; j < s.size(); j++) {
        if (s[j] == s[j - 1]) {
            curnum++;
            continue;
        }
        if (curnum != 1) ans += to_string(curnum);
        ans += s[j - 1];
        curnum = 1;
    }
    if (curnum != 1) ans += to_string(curnum);
    ans += s.back();
    return ans;
}

string gen() {
    int n = rand() % 6;
    string ans;

    for (int i = 0; i < n; i++) {
        ans += S[rand() % 4];
    }
    return code(ans);
}

pair <pair <int, pair <int, char>>, pair <int, pair <int, char>>> stupid(string s) {
    vector <pair <int, char>> t;

    int curnum = 0;

    for (int i = 0; i < s.size(); i++) {
        if ('0' <= s[i] && s[i] <= '9') {
            curnum *= 10;
            curnum += (s[i] - '0');
        } else {
            if (curnum == 0) {
                t.emplace_back(1, s[i]);
            } else {
                t.emplace_back(curnum, s[i]);
            }
            curnum = 0;
        }
    }

    string F;

    for (int i = 0; i < t.size(); i++) {
        for (int j = 0; j < t[i].first; j++) {
            F += t[i].second;
        }
    }

    // delete

    int minans = 1000000000, maxans = -1000000000;
    int mintype = -1, maxtype = -1;
    int minpos = -1, maxpos = -1;
    char minchar = 'X', maxchar = 'X';

    for (int i = 0; i < F.size(); i++) {
        string H;

        for (int j = 0; j < i; j++) {
            H += F[j];
        }
        for (int j = i + 1; j < F.size(); j++) {
            H += F[j];
        }

        string ans = code(H);
        int ANS = ans.size();

        if (ans.size() < minans) {
            minans = ans.size();
            mintype = 2;
            minpos = i + 1;
        }

        if (ANS > maxans) {
            maxans = ans.size();
            maxtype = 2;
            maxpos = i + 1;
        }
    }


    //change

    for (int i = 0; i < F.size(); i++) {
        for (char nc : S) {
            if (nc == F[i]) continue;
            string H = F;
            H[i] = nc;
            string ans = code(H);

            if (ans.size() < minans) {
                minans = ans.size();
                mintype = 3;
                minpos = i + 1;
                minchar = nc;
            }
            if (ans.size() > maxans) {
                maxans = ans.size();
                maxtype = 3;
                maxpos = i + 1;
                maxchar = nc;
            }
        }
    }

    //insert

    for (int i = 0; i < F.size(); i++) {
        for (char nc : S) {
            string H;
            for (int j = 0; j < i; j++) {
                H += F[j];
            }
            H += nc;
            for (int j = i; j < F.size(); j++) {
                H += F[j];
            }

            string ans = code(H);

            if (ans.size() < minans) {
                minans = ans.size();
                mintype = 1;
                minpos = i;
                minchar = nc;
            }
            if (ans.size() > maxans) {
                maxans = ans.size();
                maxtype = 1;
                maxpos = i;
                maxchar = nc;
            }
        }
    }

    for (char nc : S) {
        string H = F + nc;

        string ans = code(H);

        if (ans.size() < minans) {
            minans = ans.size();
            mintype = 1;
            minpos = F.size();
            minchar = nc;
        }
        if (ans.size() > maxans) {
            maxans = ans.size();
            maxtype = 1;
            maxpos = F.size();
            maxchar = nc;
        }
    }

//    cout << mintype << " " << minpos;
//    if (mintype == 2) {
//        cout << endl;
//    } else {
//        cout << " " << minchar << endl;
//    }
//
//    cout << maxtype << " " << maxpos;
//    if (maxtype == 2) {
//        cout << endl;
//    } else {
//        cout << " " << maxchar << endl;
//    }

    STMINANS = minans;
    STMAXANS = maxans;
    return {{mintype, {minpos, minchar}}, {maxtype, {maxpos, maxchar}}};
}

pair <pair <int, pair <int, char>>, pair <int, pair <int, char>>> smart(string s) {
    vector <pair <int, char>> t;

    t.emplace_back(0, 0);
    t.emplace_back(0, 0);

    int curnum = 0;

    for (int i = 0; i < s.size(); i++) {
        if ('0' <= s[i] && s[i] <= '9') {
            curnum *= 10;
            curnum += (s[i] - '0');
        } else {
            if (curnum == 0) {
                t.emplace_back(1, s[i]);
            } else {
                t.emplace_back(curnum, s[i]);
            }
            curnum = 0;
        }
    }

    t.emplace_back(0, 0);
    t.emplace_back(0, 0);
    vector <int> pref(t.size()), suf(t.size());
    vector <int> lpref(t.size()), lsuf(t.size());

    for (int i = 1; i < t.size(); i++) {
        int gs = get_size(t[i].first);
        pref[i] = pref[i - 1] + gs;
        if (gs > 1) pref[i]++;
        lpref[i] = lpref[i - 1] + t[i].first;
    }

    for (int i = t.size() - 2; i > -1; i--) {
        int gs = get_size(t[i].first);
        suf[i] = suf[i + 1] + get_size(t[i].first);
        if (gs > 1) suf[i]++;
        lsuf[i] = lsuf[i + 1] + t[i].first;
    }

    int minval = 1000000000, maxval = -1000000000;
    int mintype = -1, maxtype = -1;
    int minpos = -1, maxpos = -1;
    char minchar = 'X', maxchar = 'X';

    //delete operation

    for (int i = 2; i < t.size() - 2; i++) {
        int curans = 0;
        if (t[i].first == 1) {
            if (t[i - 1].second == t[i + 1].second) {
                if (t[i - 1].second != 0) {
                    curans = pref[i - 2] + get_size(t[i - 1].first + t[i + 1].first) + 1 + suf[i + 2];
                } else {
                    curans = 0;
                }
            }
        } else if (t[i].first == 2) {
            curans = pref[i - 1] + suf[i + 1] + 1;
        } else {
            curans = pref[i - 1] + suf[i + 1] + get_size(t[i].first - 1) + 1;
        }

        if (curans < minval) {
            minval = curans;
            mintype = 2;
            minpos = lpref[i - 1] + 1;
        }
        if (curans > maxval) {
            maxval = curans;
            maxtype = 2;
            maxpos = lpref[i - 1] + 1;
        }
    }

    //change_operation

    for (int i = 2; i < t.size() - 2; i++) {
        char ch = t[i].second;
        int ct = t[i].first;

        if (ct == 1) {
            for (char nc : S) {
                if (nc == ch) continue;

                int curans = 0;
                int curpos = lpref[i - 1] + 1;
                char curchar = nc;

                if (nc == t[i - 1].second && nc == t[i + 1].second) {
                    curans = pref[i - 2] + suf[i + 2] + get_size(t[i - 1].first + t[i + 1].first + 1) + 1;
                }
                if (nc == t[i - 1].second && nc != t[i + 1].second) {
                    curans = pref[i - 2] + suf[i + 1] + get_size(t[i - 1].first + 1) + 1;
                }
                if (nc != t[i - 1].second && nc == t[i + 1].second) {
                    curans = pref[i - 1] + suf[i + 2] + get_size(t[i + 1].first + 1) + 1;
                }
                if (nc != t[i - 1].second && nc != t[i + 1].second) {
                    curans = pref[i - 1] + suf[i + 1] + 1;
                }

                if (curans < minval) {
                    minval = curans;
                    mintype = 3;
                    minpos = curpos;
                    minchar = curchar;
                }

                if (curans > maxval) {
                    maxval = curans;
                    maxtype = 3;
                    maxpos = curpos;
                    maxchar = curchar;
                }
            }
            continue;
        }

        if (ct == 2) {
            for (char nc : S) {
                if (nc == ch) continue;

                int curans = 0;
                int curpos = lpref[i - 1] + 1;
                char curchar = nc;

                if (nc == t[i - 1].second) {
                    curans = pref[i - 2] + get_size(t[i - 1].first + 1) + 1 + 1 + suf[i + 1];
                }

                if (nc != t[i - 1].second) {
                    curans = pref[i] + suf[i + 1];
                }

                if (curans < minval) {
                    minval = curans;
                    mintype = 3;
                    minpos = curpos;
                    minchar = curchar;
                }

                if (curans > maxval) {
                    maxval = curans;
                    maxtype = 3;
                    maxpos = curpos;
                    maxchar = curchar;
                }
            }
            for (char nc : S) {
                if (nc == ch) continue;

                int curans = 0;
                int curpos = lpref[i - 1] + 2;
                char curchar = nc;

                if (nc == t[i + 1].second) {
                    curans = pref[i - 1] + 1 + get_size(t[i + 1].first + 1) + 1 + suf[i + 2];
                }

                if (nc != t[i + 1].second) {
                    curans = pref[i] + suf[i + 1];
                }

                if (curans < minval) {
                    minval = curans;
                    mintype = 3;
                    minpos = curpos;
                    minchar = curchar;
                }

                if (curans > maxval) {
                    maxval = curans;
                    maxtype = 3;
                    maxpos = curpos;
                    maxchar = curchar;
                }
            }
            continue;
        }

        for (int cur = 1; cur <= ct; cur++) {
            for (char nc : S) {
                if (nc == ch) continue;

                int curans = 0;
                int curpos = lpref[i - 1] + cur;
                char curchar = nc;

                if (cur == 1) {
                    if (nc == t[i - 1].second) {
                        curans = pref[i - 2] + get_size(t[i - 1].first + 1) + 1 + get_size(t[i].first - 1) + 1 + suf[i + 1];
                    } else {
                        curans = pref[i - 1] + 1 + get_size(t[i].first - 1) + 1 + suf[i + 1];
                    }
                }

                if (cur == ct) {
                    if (nc == t[i + 1].second) {
                        curans = pref[i - 1] + get_size(t[i].first - 1) + 1 + get_size(t[i + 1].first + 1) + 1 + suf[i + 2];
                    } else {
                        curans = pref[i - 1] + get_size(t[i].first - 1) + 1 + 1 + suf[i + 1];
                    }
                }

                if (cur == 2 && cur == ct - 1) {
                    curans = pref[i - 1] + 1 + 1 + 1 + suf[i + 1];
                }

                if (cur == 2 && cur != ct - 1) {
                    curans = pref[i - 1] + 1 + 1 + get_size(ct - cur) + 1 + suf[i + 1];
                }

                if (cur != 2 && cur == ct - 1) {
                    curans = pref[i - 1] + get_size(cur - 1) + 1 + 1 + 1 + suf[i + 1];
                }

                if (cur != 2 && cur != ct - 1) {
                    curans = pref[i - 1] + get_size(cur - 1) + 1 + 1 + get_size(ct - cur) + 1 + suf[i + 1];
                }

                if (curans < minval) {
                    minval = curans;
                    mintype = 3;
                    minpos = curpos;
                    minchar = curchar;
                }

                if (curans > maxval) {
                    maxval = curans;
                    maxtype = 3;
                    maxpos = curpos;
                    maxchar = curchar;
                }
            }
        }
    }

    //insert operation

    for (int i = 2; i < t.size() - 2; i++) {
        char ch = t[i].second;
        int ct = t[i].first;

        for (int cur = 1; cur <= ct; cur++) {
            for (char nc : S) {
                int curans = 0;
                int curpos = lpref[i - 1] + cur - 2;
                char curchar = nc;

                if (nc == t[i].second) {
                    curans = pref[i - 1] + get_size(t[i].first + 1) + 1 + suf[i + 1];
                }

                if (cur == 1) {
                    if (nc == t[i - 1].second) {
                        curans = pref[i - 2] + get_size(t[i - 1].first + 1) + 1 + suf[i];
                    }
                    if (nc != t[i - 1].second && nc != t[i].second) {
                        curans = pref[i - 1] + 1 + suf[i];
                    }
                    if (curans < minval) {
                        minval = curans;
                        mintype = 1;
                        minpos = curpos;
                        minchar = curchar;
                    }

                    if (curans > maxval) {
                        maxval = curans;
                        maxtype = 1;
                        maxpos = curpos;
                        maxchar = curchar;
                    }
                    continue;
                }

                if (cur == 2) {
                    if (nc != t[i].second) {
                        if (ct == 2) {
                            curans = pref[i - 1] + 1 + 1 + 1 + suf[i + 1];
                        } else {
                            curans = pref[i - 1] + 1 + 1 + get_size(ct - 1) + 1 + suf[i + 1];
                        }
                    }
                    if (curans < minval) {
                        minval = curans;
                        mintype = 1;
                        minpos = curpos;
                        minchar = curchar;
                    }

                    if (curans > maxval) {
                        maxval = curans;
                        maxtype = 1;
                        maxpos = curpos;
                        maxchar = curchar;
                    }
                    continue;
                }

                if (cur == ct) {
                    if (nc != t[i].second) {
                        curans = pref[i - 1] + get_size(cur - 1) + 1 + 1 + suf[i + 1];
                    }
                    if (curans < minval) {
                        minval = curans;
                        mintype = 1;
                        minpos = curpos;
                        minchar = curchar;
                    }

                    if (curans > maxval) {
                        maxval = curans;
                        maxtype = 1;
                        maxpos = curpos;
                        maxchar = curchar;
                    }
                    continue;
                }

                if (cur != 1 && cur != 2 && cur != ct) {
                    if (nc != t[i].second) {
                        curans = pref[i - 1] + get_size(cur - 1) + 1 + 1 + get_size(ct - cur) + 1 + suf[i + 1];
                    }
                    if (curans < minval) {
                        minval = curans;
                        mintype = 1;
                        minpos = curpos;
                        minchar = curchar;
                    }

                    if (curans > maxval) {
                        maxval = curans;
                        maxtype = 1;
                        maxpos = curpos;
                        maxchar = curchar;
                    }
                    continue;
                }

                if (curans < minval) {
                    minval = curans;
                    mintype = 1;
                    minpos = curpos;
                    minchar = curchar;
                }

                if (curans > maxval) {
                    maxval = curans;
                    maxtype = 1;
                    maxpos = curpos;
                    maxchar = curchar;
                }
            }
        }

        if (i == t.size() - 3) {
            for (char nc : S) {
                int curans = 0;
                int curpos = lpref[i];
                char curchar = nc;

                if (nc == t[i].second) {
                    curans = pref[i - 1] + get_size(t[i].first + 1) + 1;
                } else {
                    curans = pref[i] + 1;
                }

                if (curans < minval) {
                    minval = curans;
                    mintype = 1;
                    minpos = curpos;
                    minchar = curchar;
                }

                if (curans > maxval) {
                    maxval = curans;
                    maxtype = 1;
                    maxpos = curpos;
                    maxchar = curchar;
                }
            }
        }
    }

    cout << mintype << " " << minpos;
    if (mintype == 2) {
        cout << endl;
    } else {
        cout << " " << minchar << endl;
    }

    cout << maxtype << " " << maxpos;
    if (maxtype == 2) {
        cout << endl;
    } else {
        cout << " " << maxchar << endl;
    }
    SMMINANS = minval;
    SMMAXANS = maxval;
    return {{mintype, {minpos, minchar}}, {maxtype, {maxpos, maxchar}}};
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    string s;

    cin >> s;

    smart(s);
//    while (true) {
//        string cur = gen();
//
//        auto ans1 = stupid(cur);
//        auto ans2 = smart(cur);
//
//        if (ans1 != ans2 && STMINANS != SMMINANS && STMAXANS != SMMAXANS) {
//            cout << cur << endl;
//
//            cout << ans1.first.first << " " << ans1.first.second.first << " " << ans1.first.second.second << endl;
//            cout << ans1.second.first << " " << ans1.second.second.first << " " << ans1.second.second.second << endl;
//
//            cout << ans2.first.first << " " << ans2.first.second.first << " " << ans2.first.second.second << endl;
//            cout << ans2.second.first << " " << ans2.second.second.first << " " << ans2.second.second.second << endl;
//            return 0;
//        }
//    }
}