#include <bits/stdc++.h>

using namespace std;
bool t[11][11];
int n, m;
int k;
int type;

int is_correct_pos(int &a, int &b, int &c, int &d) {
    if ((a == b || a == c || a == d || b == c || b == d || c == d)) return 0;
    pair <int, int> p1 = {a / m, a % m};
    pair <int, int> p2 = {b / m, b % m};
    pair <int, int> p3 = {c / m, c % m};
    pair <int, int> p4 = {d / m, d % m};
    if (!(p1.first == p2.first && p1.second != p2.second && p1.first != p3.first && p1.second == p3.second &&
          p2.first != p4.first && p2.second == p4.second)) return 0;
    if ((t[p1.first][p1.second] == t[p2.first][p2.second] && t[p2.first][p2.second] == t[p3.first][p3.second] &&
             t[p3.first][p3.second] == t[p4.first][p4.second])) return 1;
    return 2;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> m >> type;

    k = n * m;

    for (long long mask = 0; mask < (1 << k); mask++) {
        memset(t, 0, sizeof(t));
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                t[i][j] = ((mask >> (i * m + j)) & 1);
            }
        }

        bool ans = 1;
        for (int pos1 = 0; pos1 < k; pos1++) {
            for (int pos2 = 0; pos2 < k; pos2++) {
                for (int pos3 = 0; pos3 < k; pos3++) {
                    for (int pos4 = 0; pos4 < k; pos4++) {
                        if (is_correct_pos(pos1, pos2, pos3, pos4) == 1) {
                            ans = 0;
                            break;
                        }
                    }
                }
            }
        }
        if (ans) {
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    cout << (int)(t[i][j] + 1) << " ";
                }
                cout << endl;
            }
            return 0;
        }
    }
}