#include <bits/stdc++.h>

using namespace std;

struct tr{
    int a, b, c, t = 0;

    tr() = default;
    tr(char a, char b, char c) : a(a - '0'), b(b - '0'), c(c - '0') {}
};

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    string a, b, c;

    cin >> a >> b >> c;

    int n = a.size();

    vector <tr> k(n);


    for (int i = 0; i < n; i++) {
        k[i] = tr(a[i], b[i], c[i]);
    }
    sort(k.begin(), k.end(), [](tr &x, tr &y) {
        if (x.a != y.a) return (x.a < y.a);
        if (x.b != y.b) return (x.b < y.b);
        if (x.c != y.c) return (x.c < y.c);
        return x.t < y.t;
    });

    for (int i = 1; i < k.size(); i++) {
        if (k[i].a == k[i + 1].a && k[i].b == k[i + 1].b && k[i].c == k[i + 1].c) {
            k[i + 1].t = k[i].t + 1;
        }
    }

    long long ans = 0;
    do {
        if (k[0].a == 0 || k[0].b == 0 || k[0].c == 0) continue;
        long long A = 0, B = 0, C = 0;
        for (int i = 0; i < n; i++) {
            A *= 10;
            A += k[i].a;
            B *= 10;
            B += k[i].b;
            C *= 10;
            C += k[i].c;
        }
        if (A + B == C) ans++;
    } while (next_permutation(k.begin(), k.end(), [](tr &x, tr &y) {
        if (x.a != y.a) return (x.a < y.a);
        if (x.b != y.b) return (x.b < y.b);
        if (x.c != y.c) return (x.c < y.c);
        return x.t < y.t;
    }));

    cout << ans;
    return 0;
}